#include "drivers/vga_text.hpp"

using bitmap = std::uint8_t[8];

static const int ascii_start = 0x20;
bitmap ascii[] = {
    { // space
        0b00000000, // asc
        0b00000000,
        0b00000000, // xline
        0b00000000,
        0b00000000,
        0b00000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // !
        0b00010000, // asc
        0b00010000,
        0b00010000, // xline
        0b00010000,
        0b00000000,
        0b00010000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // "
        0b00100100, // asc
        0b00100100,
        0b00000000, // xline
        0b00000000,
        0b00000000,
        0b00000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // #
        0b00010010, // asc
        0b00010010,
        0b11111111, // xline
        0b00100100,
        0b11111110,
        0b01001000, // baseline
        0b01001000,
        0b00000000, // desc
    },
    { // $
        0b00001000, // asc
        0b00111100,
        0b01001000, // xline
        0b00111100,
        0b00001010,
        0b00111100, // baseline
        0b00001000,
        0b00000000, // desc
    },
    { // %
        0b01000010, // asc
        0b10100100,
        0b01001000, // xline
        0b00010010,
        0b00100101,
        0b01000010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // &
        0b00111000, // asc
        0b01000100,
        0b00110000, // xline
        0b01011010,
        0b01000100,
        0b00111010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // '
        0b00010000, // asc
        0b00010000,
        0b00000000, // xline
        0b00000000,
        0b00000000,
        0b00000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // (
        0b00000100, // asc
        0b00001000,
        0b00010000, // xline
        0b00010000,
        0b00010000,
        0b00010000, // baseline
        0b00001000,
        0b00000100, // desc
    },
    { // )
        0b00100000, // asc
        0b00010000,
        0b00001000, // xline
        0b00001000,
        0b00001000,
        0b00001000, // baseline
        0b00010000,
        0b00100000, // desc
    },
    { // *
        0b01000100, // asc
        0b00101000,
        0b11111110, // xline
        0b00101000,
        0b01000100,
        0b00000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // +
        0b00000000, // asc
        0b00010000,
        0b00010000, // xline
        0b01111100,
        0b00010000,
        0b00010000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // ,
        0b00000000, // asc
        0b00000000,
        0b00000000, // xline
        0b00000000,
        0b00000000,
        0b00011000, // baseline
        0b00001000,
        0b00010000, // desc
    },
    { // -
        0b00000000, // asc
        0b00000000,
        0b00000000, // xline
        0b01111110,
        0b00000000,
        0b00000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // .
        0b00000000, // asc
        0b00000000,
        0b00000000, // xline
        0b00000000,
        0b00000000,
        0b00011000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // /
        0b00000010, // asc
        0b00000100,
        0b00001000, // xline
        0b00010000,
        0b00100000,
        0b01000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // 0
        0b00111100, // asc
        0b01000110,
        0b01001010, // xline
        0b01010010,
        0b01100010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // 1
        0b00010000, // asc
        0b00110000,
        0b00010000, // xline
        0b00010000,
        0b00010000,
        0b00111000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // 2
        0b00111100, // asc
        0b01000010,
        0b00000100, // xline
        0b00011000,
        0b00100000,
        0b01111110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // 3
        0b01111100, // asc
        0b00000010,
        0b00011100, // xline
        0b00000010,
        0b00000010,
        0b01111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // 4
        0b00001100, // asc
        0b00010100,
        0b00100100, // xline
        0b01000100,
        0b01111110,
        0b00000100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // 5
        0b01111100, // asc
        0b01000000,
        0b01111100, // xline
        0b00000010,
        0b00000010,
        0b01111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // 6
        0b00111100, // asc
        0b01000000,
        0b01111100, // xline
        0b01000010,
        0b01000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // 7
        0b01111110, // asc
        0b00000010,
        0b00000100, // xline
        0b00000100,
        0b00001000,
        0b00001000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // 8
        0b00111100, // asc
        0b01000010,
        0b00111100, // xline
        0b01000010,
        0b01000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // 9
        0b00111100, // asc
        0b01000010,
        0b01000010, // xline
        0b00111110,
        0b00000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // :
        0b00000000, // asc
        0b00000000,
        0b00011000, // xline
        0b00000000,
        0b00000000,
        0b00011000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // ;
        0b00000000, // asc
        0b00000000,
        0b00011000, // xline
        0b00000000,
        0b00000000,
        0b00011000, // baseline
        0b00001000,
        0b00010000, // desc
    },
    { // <
        0b00000000, // asc
        0b00000110,
        0b00011000, // xline
        0b01100000,
        0b00011000,
        0b00000110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // =
        0b00000000, // asc
        0b00000000,
        0b01111110, // xline
        0b00000000,
        0b01111110,
        0b00000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // >
        0b00000000, // asc
        0b01100000,
        0b00011000, // xline
        0b00000110,
        0b00011000,
        0b01100000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // ?
        0b00111000, // asc
        0b01000100,
        0b00000100, // xline
        0b00001000,
        0b00000000,
        0b00001000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // @
        0b00111100, // asc
        0b01000010,
        0b10011010, // xline
        0b10101010,
        0b10111100,
        0b10000000, // baseline
        0b01111100,
        0b00000000, // desc
    },
    { // A
        0b00011000, // asc
        0b00100100,
        0b01000010, // xline
        0b01111110,
        0b01000010,
        0b01000010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // B
        0b01111100, // asc
        0b01000010,
        0b01111100, // xline
        0b01000010,
        0b01000010,
        0b01111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // C
        0b00111100, // asc
        0b01000010,
        0b01000000, // xline
        0b01000000,
        0b01000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // D
        0b01110000, // asc
        0b01001000,
        0b01000100, // xline
        0b01000100,
        0b01000100,
        0b01111000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // E
        0b01111110, // asc
        0b01000000,
        0b01111100, // xline
        0b01000000,
        0b01000000,
        0b01111110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // F
        0b01111110, // asc
        0b01000000,
        0b01111100, // xline
        0b01000000,
        0b01000000,
        0b01000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // G
        0b00111100, // asc
        0b01000010,
        0b01000000, // xline
        0b01001110,
        0b01000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // H
        0b01000010, // asc
        0b01000010,
        0b01111110, // xline
        0b01000010,
        0b01000010,
        0b01000010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // I
        0b00111110, // asc
        0b00001000,
        0b00001000, // xline
        0b00001000,
        0b00001000,
        0b00111110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // J
        0b01111110, // asc
        0b00000010,
        0b00000010, // xline
        0b00000010,
        0b01000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // K
        0b01000100, // asc
        0b01001000,
        0b01110000, // xline
        0b01010000,
        0b01001000,
        0b01000100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // L
        0b01000000, // asc
        0b01000000,
        0b01000000, // xline
        0b01000000,
        0b01000000,
        0b01111110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // M
        0b01000010, // asc
        0b01100110,
        0b01011010, // xline
        0b01000010,
        0b01000010,
        0b01000010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // N
        0b01000010, // asc
        0b01100010,
        0b01010010, // xline
        0b01001010,
        0b01000110,
        0b01000010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // O
        0b00111100, // asc
        0b01000010,
        0b01000010, // xline
        0b01000010,
        0b01000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // P
        0b01111100, // asc
        0b01000010,
        0b01000010, // xline
        0b01111100,
        0b01000000,
        0b01000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // Q
        0b00111100, // asc
        0b01000010,
        0b01000010, // xline
        0b01000010,
        0b01000010,
        0b00111100, // baseline
        0b00001000,
        0b00000100, // desc
    },
    { // R
        0b01111000, // asc
        0b01000100,
        0b01000100, // xline
        0b01111000,
        0b01001000,
        0b01000100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // S
        0b00111100, // asc
        0b01000010,
        0b00110000, // xline
        0b00001100,
        0b01000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // T
        0b01111100, // asc
        0b00010000,
        0b00010000, // xline
        0b00010000,
        0b00010000,
        0b00010000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // U
        0b01000010, // asc
        0b01000010,
        0b01000010, // xline
        0b01000010,
        0b01000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // V
        0b01000010, // asc
        0b01000010,
        0b00100100, // xline
        0b00100100,
        0b00011000,
        0b00011000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // W
        0b01000010, // asc
        0b01000010,
        0b01010010, // xline
        0b01010010,
        0b01010010,
        0b00101100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // X
        0b01000010, // asc
        0b00100100,
        0b00011000, // xline
        0b00011000,
        0b00100100,
        0b01000010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // Y
        0b01000100, // asc
        0b01000100,
        0b00101000, // xline
        0b00010000,
        0b00010000,
        0b00010000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // Z
        0b01111110, // asc
        0b00000100,
        0b00001000, // xline
        0b00010000,
        0b00100000,
        0b01111110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // [
        0b00111000, // asc
        0b00100000,
        0b00100000, // xline
        0b00100000,
        0b00100000,
        0b00111000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // backslash
        0b01000000, // asc
        0b00100000,
        0b00010000, // xline
        0b00001000,
        0b00000100,
        0b00000010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // ]
        0b00111000, // asc
        0b00001000,
        0b00001000, // xline
        0b00001000,
        0b00001000,
        0b00111000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // ^
        0b00010000, // asc
        0b00101000,
        0b01000100, // xline
        0b00000000,
        0b00000000,
        0b00000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // _
        0b00000000, // asc
        0b00000000,
        0b00000000, // xline
        0b00000000,
        0b00000000,
        0b01111110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // `
        0b00100000, // asc
        0b00010000,
        0b00001000, // xline
        0b00000000,
        0b00000000,
        0b00000000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // a
        0b00000000, // asc
        0b00111100,
        0b00000010, // xline
        0b00111110,
        0b01000010,
        0b00111110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // b
        0b01000000, // asc
        0b01000000,
        0b01111100, // xline
        0b01000010,
        0b01000010,
        0b01111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // c
        0b00000000, // asc
        0b00000000,
        0b00111110, // xline
        0b01000000,
        0b01000000,
        0b00111110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // d
        0b00000010, // asc
        0b00000010,
        0b00111110, // xline
        0b01000010,
        0b01000010,
        0b00111110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // e
        0b00000000, // asc
        0b00111100,
        0b01000010, // xline
        0b01111100,
        0b01000000,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // f
        0b00001110, // asc
        0b00010000,
        0b00111100, // xline
        0b00010000,
        0b00010000,
        0b00010000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // g
        0b00000000, // asc
        0b00000000,
        0b00111110, // xline
        0b01000010,
        0b01000010,
        0b00111110, // baseline
        0b00000010,
        0b00111100, // desc
    },
    { // h
        0b01000000, // asc
        0b01000000,
        0b01111100, // xline
        0b01000010,
        0b01000010,
        0b01000010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // i
        0b00001000, // asc
        0b00000000,
        0b00011000, // xline
        0b00001000,
        0b00001000,
        0b00011100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // j
        0b00001000, // asc
        0b00000000,
        0b00011000, // xline
        0b00001000,
        0b00001000,
        0b00001000, // baseline
        0b00001000,
        0b00110000, // desc
    },
    { // k
        0b01000000, // asc
        0b01000000,
        0b01001110, // xline
        0b01110000,
        0b01001000,
        0b01000110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // l
        0b00110000, // asc
        0b00010000,
        0b00010000, // xline
        0b00010000,
        0b00010000,
        0b00001100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // m
        0b00000000, // asc
        0b00000000,
        0b01111100, // xline
        0b01001010,
        0b01001010,
        0b01000010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // n
        0b00000000, // asc
        0b00000000,
        0b01111100, // xline
        0b01000010,
        0b01000010,
        0b01000010, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // o
        0b00000000, // asc
        0b00000000,
        0b00111100, // xline
        0b01000010,
        0b01000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // p
        0b00000000, // asc
        0b00000000,
        0b01111100, // xline
        0b01000010,
        0b01000010,
        0b01111100, // baseline
        0b01000000,
        0b01000000, // desc
    },
    { // q
        0b00000000, // asc
        0b00000000,
        0b00111110, // xline
        0b01000010,
        0b01000010,
        0b00111110, // baseline
        0b00000010,
        0b00000010, // desc
    },
    { // r
        0b00000000, // asc
        0b00110110,
        0b00011000, // xline
        0b00010000,
        0b00010000,
        0b00010000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // s
        0b00000000, // asc
        0b00111100,
        0b01000000, // xline
        0b00111100,
        0b00000010,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // t
        0b00010000, // asc
        0b01111100,
        0b00010000, // xline
        0b00010000,
        0b00010000,
        0b00001100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // u
        0b00000000, // asc
        0b00000000,
        0b01000100, // xline
        0b01000100,
        0b01000100,
        0b00111100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // v
        0b00000000, // asc
        0b00000000,
        0b01000010, // xline
        0b01000010,
        0b00100100,
        0b00011000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // w
        0b00000000, // asc
        0b00000000,
        0b01000010, // xline
        0b01000010,
        0b01001010,
        0b00110100, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // x
        0b00000000, // asc
        0b00000000,
        0b01100110, // xline
        0b00011000,
        0b00011000,
        0b01100110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // y
        0b00000000, // asc
        0b00000000,
        0b01000010, // xline
        0b01000010,
        0b01000010,
        0b00111110, // baseline
        0b00000010,
        0b00111100, // desc
    },
    { // z
        0b00000000, // asc
        0b00000000,
        0b00111110, // xline
        0b00001100,
        0b00110000,
        0b01111110, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // {
        0b00001100, // asc
        0b00010000,
        0b00010000, // xline
        0b00100000,
        0b00010000,
        0b00010000, // baseline
        0b00001100,
        0b00000000, // desc
    },
    { // |
        0b00010000, // asc
        0b00010000,
        0b00010000, // xline
        0b00010000,
        0b00010000,
        0b00010000, // baseline
        0b00000000,
        0b00000000, // desc
    },
    { // }
        0b00110000, // asc
        0b00001000,
        0b00001000, // xline
        0b00000100,
        0b00001000,
        0b00001000, // baseline
        0b00110000,
        0b00000000, // desc
    },
    { // ~
        0b00000000, // asc
        0b00000000, // xline
        0b00110000,
        0b01001001,
        0b00000110, // baseline
        0b00000000,
        0b00000000,
        0b00000000, // desc
    },
};

void print_char_line(std::uint8_t line, unsigned x, unsigned y, std::uint8_t fgcolor, std::uint8_t bgcolor)
{
    for ( int i = 7; i >= 0; i-- )
    {
        vga::VideoMode::buffer()[x+i+y*vga::VideoMode::screen_columns] = (line & 1) ? fgcolor : bgcolor;
        line = (line & 0xfe) >> 1;
    }
}

void vga::VideoMode::write_char(std::size_t offset, char c, tty::Style style)
{
    if ( c < ascii_start || unsigned(c) >= sizeof(ascii) / sizeof(ascii[0]) + ascii_start )
        return;

    auto x = offset % vga::VideoMode::screen_columns;
    auto y = offset / vga::VideoMode::screen_columns;
    for ( int i = 0; i < 8; i++ )
    {
        print_char_line(ascii[c-ascii_start][i], x, y+i, style.foreground, style.background);
    }
}
